﻿using System;
using System.Diagnostics;
using System.Net;
using System.Text;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WebForms;

namespace _9338
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // Set the Map Unit. The reason for setting it to DecimalDegrees is that is what the shapefile’s unit of measure is inherently in.
                Map1.MapUnit = GeographyUnit.Meter;

                WmtsLayer wmtsLayer = new ThinkGeo.MapSuite.Layers.WmtsLayer();

                wmtsLayer.SendingWebRequest += WmtsLayer_SendingWebRequest;

                wmtsLayer.DrawingExceptionMode = DrawingExceptionMode.DrawException;
                wmtsLayer.WmtsSeverEncodingType = ThinkGeo.MapSuite.Layers.WmtsSeverEncodingType.Kvp;
                wmtsLayer.ServerUris.Add(new Uri("https://35.200.222.237/wx/api/map/satir/wmts/"));
                wmtsLayer.Open();
                
                wmtsLayer.ActiveLayerName = "satir";
                wmtsLayer.ActiveStyleName = "avncolor";
                wmtsLayer.TileMatrixSetName = "GoogleMapsCompatible";
                wmtsLayer.OutputFormat = "image/png";
                
                LayerOverlay layerOverlay = new LayerOverlay();
                layerOverlay.Layers.Add(wmtsLayer);
                Map1.CustomOverlays.Add(layerOverlay);


                Map1.CurrentExtent = new RectangleShape(-20037508.34278925, 20037508.34278925, 20037508.34278925, -20037508.34278925);
            }
        }

        private void WmtsLayer_SendingWebRequest(object sender, SendingWebRequestEventArgs e)
        {
            Debug.WriteLine(e.WebRequest.RequestUri.ToString());

            var request = WebRequest.Create(e.WebRequest.RequestUri.ToString());
            string authInfo = "yourusername:yourpassword";
            authInfo = Convert.ToBase64String(Encoding.Default.GetBytes(authInfo));

            request.Headers["Authorization"] = "Basic " + authInfo;

            e.WebRequest = request;
        }
    }
}